"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _core() {
  const data = require("@parcel/core");

  _core = function () {
    return data;
  };

  return data;
}

function _package() {
  const data = _interopRequireDefault(require("../package.json"));

  _package = function () {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

let HANDLE_ID = 0; // $FlowFixMe

const handleById = new Map();

class Handle {
  constructor(opts) {
    var _opts$id;

    _defineProperty(this, "id", void 0);

    _defineProperty(this, "childId", void 0);

    _defineProperty(this, "fn", void 0);

    this.id = (_opts$id = opts.id) !== null && _opts$id !== void 0 ? _opts$id : ++HANDLE_ID;
    this.fn = opts.fn;
    this.childId = opts.childId;
    handleById.set(this.id, this);
  }

  dispose() {
    handleById.delete(this.id);
  }

  serialize() {
    return {
      id: this.id,
      childId: this.childId
    };
  }

  static deserialize(opts) {
    return new Handle(opts);
  }

} // Register the Handle as a serializable class so that it will properly be deserialized
// by anything that uses WorkerFarm.


exports.default = Handle;
(0, _core().registerSerializableClass)(`${_package().default.version}:Handle`, Handle);